EDIT - bug #7036

bug # 7035 (Rejected): Vaadin views keeping connection open as long as the view has not exited

correctly release vaadin view resources when the browser windows has been closed

10/25/2017 05:03 PM - Andreas Kohlbecker

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Andreas Kohlbecker % Done: 100%
Category: cdm-vaadin Estimated time: 0:00 hour
Target version: Release 5.4

Severity: normal Found in Version:

Description

Related issues:

Related to EDIT - bug #7046: replace open session per view pattern by DTO str... Closed
Related to EDIT - bug #6687: Multiple representations of the same entity merg... Closed
Related to EDIT - bug #7047: Vaadin Ul and View scope beans are not always de... Closed

Associated revisions

Revision 948d9990 - 10/26/2017 11:04 AM - Andreas Kohlbecker

ref #7036 implementing DetachListener in DistributionStatusUI to relase db connections for unused Views

Revision 7e488d1b - 10/27/2017 11:20 AM - Andreas Kohlbecker

ref #7036 disposing resources in mvp beans

Revision 157¢9¢3d - 10/27/2017 11:25 AM - Andreas Kohlbecker

ref #7036 LoginView in View scope helps disposing this bean
it is no longer required to have it in the UlScope

Revision b14494a9 - 10/24/2018 02:53 PM - Andreas Kohlbecker

fix #7036 making sure all spring beans are disposed when the vaadin session times out

e RegistrationToolbar, RegistrationUl, RegistrationWorkingsetPresenter, NavigationManagerBean as DisposableBean
¢ seetting the vaadin closeldleSessions parameter to true in web.xml

History

#1 - 11/02/2017 10:55 AM - Andreas Kohlbecker

- Related to bug #7047: Vaadin Ul and View scope beans are not always destroyed correctly added

#2 - 11/02/2017 12:32 PM - Andreas Kohlbecker
- Related to deleted (bug #7047: Vaadin Ul and View scope beans are not always destroyed correctly)

#3 - 11/02/2017 12:32 PM - Andreas Kohlbecker

- Has duplicate bug #7047: Vaadin Ul and View scope beans are not always destroyed correctly added

#4 - 11/02/2017 12:33 PM - Andreas Kohlbecker
- Description updated

- Status changed from New to In Progress

#5 - 11/02/2017 12:33 PM - Andreas Kohlbecker
- Tags set to phycobank
- Priority changed from Highest to Priority13

- Target version changed from Release 4.11 to Reviewed Next Major Release
- Severity changed from blocker to normal

#6 - 11/02/2017 12:34 PM - Andreas Kohlbecker
- Related to bug #7046: replace open session per view pattern by DTO strategy added

#7 - 11/02/2017 12:35 PM - Andreas Kohlbecker
- Related to bug #6687: Multiple representations of the same entity merge problem added

#8 - 11/02/2017 12:36 PM - Andreas Kohlbecker

- Subject changed from correctly release vaadin view resources when the browser windows has been closed to correctly release vaadin view ad Ul
resources

#9 - 11/02/2017 12:36 PM - Andreas Kohlbecker

- Has duplicate deleted (bug #7047: Vaadin Ul and View scope beans are not always destroyed correctly)

#10 - 11/02/2017 12:37 PM - Andreas Kohlbecker

- Related to bug #7047: Vaadin Ul and View scope beans are not always destroyed correctly added

#11 - 11/02/2017 12:38 PM - Andreas Kohlbecker

- Subject changed from correctly release vaadin view ad Ul resources to correctly release vaadin view resources when the browser windows has been
closed

- Description updated

#12 - 10/23/2018 12:47 PM - Andreas Kohlbecker
- Priority changed from Priority13 to Highest

- Target version changed from Reviewed Next Major Release to Release 5.5

it seems as this is not yet solved.

#13 - 10/23/2018 04:57 PM - Andreas Kohlbecker
- File picture893-1.png added

after editing in parallel with 3 users for some time and closing all browser tabs afterwards, some spring beans like the LoginPresenter and the
RegistrationWorkingsetPresenter and View are not disposed:
|C| eu.etakonomy. cdm.vaadin.component.ButtonFactory 6 0% 192 0% =192 0%
[c] eu.etaxonemy.cdm.vaadin/component.common.FilterableAnnotationsField 6 0% 1,056 0% =1,056 0%
[c] eu.etaxonomy.cdm.vaadin.component.common.FilterableAnnotationsField$1 6 0% g6 0% =896 0%
(] eu.etaxonomy. cdm.vaadin. util filter. CdmTermFilter 6 0% 144 0% =144 0%
[c] eu.etaxonomy.cdm.vaadin.view. LoginPresenter 6 0% 240 0% =70,352 0%
|| eu.etaxonomy.cdm.vaadin.view.registration.RegistrationWorkingsetPresenter . 6 0% 384 0% =1,812 0%
Reachability | Class Loaders | Web Applications | Allocations | Ages | Class Statics | Class Hierarchy | Quick Info

Merged Paths Object Explorer Generations
© Merged paths to objects selected in the upper table
Name Objects Retained Size Dominators
B <Al the objects= 6 100 % 1.8121
=l =Retained from several objects simultaneously (don't have a dominator)= 3 1,720
R (€] eu.etaxonomy.cdm.vaadin.view. registration.RegistrationWorkingsetPresenter$l
B || eu.etakonomy. cdm.vaadin.view.registration. RegistrationWorksetViewBean
B |C] java.util.concurrent.ConcurrentHashMap $Mode
R’ (€] org.springframework. beans.factory. support.DisposableBeanAdapter
= B || org.vaadinspring.events.internal MethodListenerWrapper
B R |c] java.uti.HashMap$Node
B B (€] java. util. HashMap$Node
B R [C] java.util.HashMap$Node
E & [C] java.util. HashMap $Node(]
E B |C] java.util.HashMap
B R |c] java.util. HashSet
E & [C| org.vaadin.spring. events.internal.ListenerCollection
E |C| org.waadin.spring.events.internal.ScopedEventBus$DefualtvViewEventBus
R (€] java.uti.HashMap $Node(]
B B [C] java util. HashMap$Node(]
= & [C] java.util. HashMap
R [C] java.util.HashSet
=0bjects unreachable from GC roots= 3 0% 1892 10%

#14 - 10/23/2018 06:08 PM - Andreas Kohlbecker

the problem seems mainly to be caused by the NavigationManagerBean not releasing the references to RegistrationWorksetViewBeans contained in
currentView and by the PopupViewRegistration keeping the RegistrationWorksetViewBean in the popupViewFieldMap where its used as key.

#15 - 10/23/2018 06:37 PM - Andreas Kohlbecker

Resources which are still in memory after closing a browser window should be destroyed automatically once the next heardbeat has reached the

server.

It is defined by the @VaadinServletConfiguration.InitParameterName(value="heartbeatinterval"):

5.8.5. Ul Expiration

Ul instances are cleaned up if no communication is received from them after some time. If no
other server requests are made, the client-side sends keep-alive heartbeat requests. A Ul is

kept alive for as long as requests or heartbeats are received from it. It expires if three consecutive
heartbeats are missed.

The heartbeatInterval is at 5 minutes (300 seconds) per default.

#16 - 10/24/2018 02:53 PM - Andreas Kohlbecker

- Status changed from In Progress to Resolved

- % Done changed from 0 to 50

Applied in changeset cdm-vaadin|b14494a9c3be6a70f64c4560209ba8d406eb635f.

#17 - 10/24/2018 02:54 PM - Andreas Kohlbecker

- Status changed from Resolved to Closed

- Target version changed from Release 5.5 to Release 5.4

- % Done changed from 50 to 100

now all spring beans like RegistrationToolbar, RegistrationUl, RegistrationWorkingsetPresenter, NavigationManagerBean are disposed when the
session times out due to inactivity.
https://dev.e-taxonomy.eu/redmine/projects/edit/repository/cdm-vaadin/revisions/b14494a9c3be6a70f64c4560209ba8d406eb635f

Files

picture893-1.png 56.7 KB 10/23/2018 Andreas Kohlbecker
